---
title: String length
slug: Web/JavaScript/Reference/Global_Objects/String/length
tags:
  - JavaScript
  - Property
  - Reference
  - String
  - String Length
  - length
---
<div>{{JSRef}}</div>

<p><span class="seoSummary">The <strong><code>length</code></strong> property of a {{jsxref("String")}} object contains the length of the string, in UTF-16 code units. <code>length</code> is a read-only data property of string instances.</span></p>

<div>{{EmbedInteractiveExample("pages/js/string-length.html", "shorter")}}</div>

<h2 id="Description">Description</h2>

<p>This property returns the number of code units in the string. {{interwiki("wikipedia", "UTF-16")}}, the string format used by JavaScript, uses a single 16-bit code unit to represent the most common characters, but needs to use two code units for less commonly-used characters, so it's possible for the value returned by <code>length</code> to not match the actual number of characters in the string.</p>

<p>ECMAScript 2016 (ed. 7) established a maximum length of <code>2^53 - 1</code> elements. Previously, no maximum length was specified. In Firefox, strings have a maximum length of <code>2**30 - 2</code> (~1GB). In versions prior to Firefox 65, the maximum length was <code>2**28 - 1</code> (~256MB).</p>

<p>For an empty string, <code>length</code> is 0.</p>

<p>The static property <code>String.length</code> is unrelated to the length of strings, it's the arity of the <code>String</code> function (loosely, the number of formal parameters it has), which is 1.</p>

<h2 id="Unicode">Unicode</h2>

<p>Since `length` counts code units instead of characters, if you want to get the number of characters you need something like this:</p>

<pre class="brush: js notranslate">function getCharacterLength (str) {
  // The string iterator that is used here iterates over characters,
  //  not mere code units
  return [...str].length;
}

console.log(getCharacterLength('A\uD87E\uDC04Z')); // 3

// While not recommended, you could add this to each string as follows:

Object.defineProperty(String.prototype, 'charLength', {
  get () {
    return getCharacterLength(this);
  }
});

console.log('A\uD87E\uDC04Z'.charLength); // 3
</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Basic_usage">Basic usage</h3>

<pre class="brush: js notranslate">let x = 'Mozilla';
let empty = '';

console.log(x + ' is ' + x.length + ' code units long');
/* "Mozilla is 7 code units long" */

console.log('The empty string has a length of ' + empty.length);
// expected output: "The empty string has a length of 0"</pre>

<h3 id="Assigning_to_length">Assigning to length</h3>

<pre class="brush: js notranslate">let myString = "bluebells";

// Attempting to assign a value to a string's .length property has no observable effect.
myString.length = 4;
console.log(myString);
// expected output: "bluebells"
console.log(myString.length);
// expected output: 9
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-properties-of-string-instances-length')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.String.length")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://downloads.teradata.com/blog/jasonstrimpel/2011/11/javascript-string-length-and-internationalizing-web-applications">JavaScript <code>String.length</code> and Internationalizing Web Applications</a></li>
</ul>
